SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #Nodo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!Nodo methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 20:47'!
dato 
	^self shouldBeImplemented .! !

Nodo subclass: #NodoConDato
	instanceVariableNames: 'dato'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NodoConDato methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 20:50'!
dato
	^dato.! !

!NodoConDato methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 20:44'!
initialize: aByteString 
	dato := aByteString .! !

Nodo subclass: #NodoVacio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NodoVacio methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 20:51'!
dato 
	^Error new signal: OOStack stackEmptyErrorDescription! !

Object subclass: #OOStack
	instanceVariableNames: 'isEmpty elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 20:53'!
initialize
	elements := Stack  new.
	elements  push: NodoVacio new.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 20:54'!
isEmpty
	^ (elements size -1) = 0 .! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/8/2013 18:07'!
pop
	| dato |
	
	dato := self top.
	elements pop.
	^dato.
	"( elements isEmpty ) 	ifFalse:  [ ^elements pop].
	( elements isEmpty ) 	ifTrue:  [ ^Error new signal: self class stackEmptyErrorDescription ]."! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 21:00'!
push: aByteString 
	
	elements push: (NodoConDato new initialize: aByteString)   .
	^self.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 21:01'!
size 
	^elements size -  1 .! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/6/2013 21:02'!
top
	| dato primerElemento |
	primerElemento := elements top.
	dato := primerElemento dato.
	^dato.! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
